#include <bits/stdc++.h>

#define MAX_NODES 10000

using namespace std;

using node = size_t;

#ifdef EVAL
ifstream input("input.txt");
ofstream output("output.txt");
#else
istream &input(cin);
ostream &output(cout);
#endif

array<unordered_set<node>, MAX_NODES> graph;
array<bool, MAX_NODES> visited;

bool is_edge(const node a, const node b) {
    return graph[a].find(b) != graph[a].end();
}

void bfs(node s, vector<node> &cc) {

    queue<node> todo;

    visited[s] = true;
    todo.push(s);
    cc.push_back(s);

    for (; !todo.empty(); todo.pop()) {
        const node x = todo.front();

        for (const node adj: graph[x]) {
            if (visited[adj]) continue;

            visited[adj] = true;
            todo.push(adj);
            cc.push_back(adj);
        }
    }
}

int main() {

    graph.fill({});
    visited.fill(false);

    int N, M;
    input >> N >> M;

    for (int e = 0; e < M; ++e) {
        node a, b;
        input >> a >> b;
        graph[a].insert(b);
        graph[b].insert(a);
    }

    vector<pair<node, node>> add;

    for (node v = 0; v < N; ++v) {
        if (visited[v]) continue;

        vector<node> cc;
        bfs(v, cc);

        for (size_t ia = 0, n = cc.size(); ia < n - 1; ++ia) {
            for (size_t ib = ia + 1; ib < n; ++ib) {
                const node a = cc[ia];
                const node b = cc[ib];
                if (is_edge(a, b)) continue;

                add.emplace_back(a, b);
            }
        }
    }

    output << add.size() << ' ' << 0 << endl;

    for (const auto t: add) {
        output << "+ " << t.first << ' ' << t.second << endl;
    }

    output << "***" << endl;

    return 0;
}
